Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4502)
@@ -4926,85 +5205,85 @@
 
 
-             IF ( INDEX( restart_string(1:length), '%us' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%us' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%us )  .AND.                        &
-                     ALLOCATED( surf_file%us   ) )                             & 
+                     ALLOCATED( surf_file%us   ) )                             &
                    surf_target%us(m_target) = surf_file%us(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%ol' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ol' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%ol )  .AND.                        &
-                     ALLOCATED( surf_file%ol   ) )                             & 
+                     ALLOCATED( surf_file%ol   ) )                             &
                    surf_target%ol(m_target) = surf_file%ol(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%pt_surface' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%pt_surface' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%pt_surface )  .AND.                &
-                     ALLOCATED( surf_file%pt_surface   ) )                     & 
+                     ALLOCATED( surf_file%pt_surface   ) )                     &
                    surf_target%pt_surface(m_target) = surf_file%pt_surface(m_file)
              ENDIF
-             
-             IF ( INDEX( restart_string(1:length), '%q_surface' ) /= 0 )  THEN 
+
+             IF ( INDEX( restart_string(1:length), '%q_surface' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%q_surface )  .AND.                 &
-                     ALLOCATED( surf_file%q_surface   ) )                      & 
+                     ALLOCATED( surf_file%q_surface   ) )                      &
                    surf_target%q_surface(m_target) = surf_file%q_surface(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%vpt_surface' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%vpt_surface' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%vpt_surface )  .AND.               &
-                     ALLOCATED( surf_file%vpt_surface   ) )                    & 
+                     ALLOCATED( surf_file%vpt_surface   ) )                    &
                    surf_target%vpt_surface(m_target) = surf_file%vpt_surface(m_file)
              ENDIF
-             
-             IF ( INDEX( restart_string(1:length), '%usws' ) /= 0 )  THEN 
+
+             IF ( INDEX( restart_string(1:length), '%usws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%usws )  .AND.                      &
-                     ALLOCATED( surf_file%usws   ) )                           & 
+                     ALLOCATED( surf_file%usws   ) )                           &
                    surf_target%usws(m_target) = surf_file%usws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%vsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%vsws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%vsws )  .AND.                      &
-                     ALLOCATED( surf_file%vsws   ) )                           & 
+                     ALLOCATED( surf_file%vsws   ) )                           &
                    surf_target%vsws(m_target) = surf_file%vsws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%ts' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ts' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%ts )  .AND.                        &
-                     ALLOCATED( surf_file%ts   ) )                             & 
+                     ALLOCATED( surf_file%ts   ) )                             &
                    surf_target%ts(m_target) = surf_file%ts(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%shf' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%shf' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%shf )  .AND.                       &
-                     ALLOCATED( surf_file%shf   ) )                            & 
+                     ALLOCATED( surf_file%shf   ) )                            &
                    surf_target%shf(m_target) = surf_file%shf(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%qs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qs' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%qs )  .AND.                        &
-                     ALLOCATED( surf_file%qs   ) )                             & 
+                     ALLOCATED( surf_file%qs   ) )                             &
                    surf_target%qs(m_target) = surf_file%qs(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%qsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qsws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%qsws )  .AND.                      &
-                     ALLOCATED( surf_file%qsws   ) )                           & 
+                     ALLOCATED( surf_file%qsws   ) )                           &
                    surf_target%qsws(m_target) = surf_file%qsws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%ss' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ss' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%ss )  .AND.                        &
-                     ALLOCATED( surf_file%ss   ) )                             & 
+                     ALLOCATED( surf_file%ss   ) )                             &
                    surf_target%ss(m_target) = surf_file%ss(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%ssws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ssws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%ssws )  .AND.                      &
-                     ALLOCATED( surf_file%ssws   ) )                           & 
+                     ALLOCATED( surf_file%ssws   ) )                           &
                    surf_target%ssws(m_target) = surf_file%ssws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%css' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%css' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%css )  .AND.                     &
-                     ALLOCATED( surf_file%css   ) )  THEN                  
+                     ALLOCATED( surf_file%css   ) )  THEN
                    DO  lsp = 1, nvar
                       surf_target%css(lsp,m_target) = surf_file%css(lsp,m_file)
@@ -5012,7 +5291,7 @@
                 ENDIF
              ENDIF
-             IF ( INDEX( restart_string(1:length), '%cssws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%cssws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%cssws )  .AND.                     &
-                     ALLOCATED( surf_file%cssws   ) )  THEN                  
+                     ALLOCATED( surf_file%cssws   ) )  THEN
                    DO  lsp = 1, nvar
                       surf_target%cssws(lsp,m_target) = surf_file%cssws(lsp,m_file)
@@ -5021,75 +5300,99 @@
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%qcs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qcs' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%qcs )  .AND.                       &
-                     ALLOCATED( surf_file%qcs   ) )                            & 
+                     ALLOCATED( surf_file%qcs   ) )                            &
                   surf_target%qcs(m_target) = surf_file%qcs(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%qcsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qcsws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%qcsws )  .AND.                     &
-                     ALLOCATED( surf_file%qcsws   ) )                          & 
+                     ALLOCATED( surf_file%qcsws   ) )                          &
                    surf_target%qcsws(m_target) = surf_file%qcsws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%ncs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ncs' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%ncs )  .AND.                       &
-                     ALLOCATED( surf_file%ncs   ) )                            & 
+                     ALLOCATED( surf_file%ncs   ) )                            &
                    surf_target%ncs(m_target) = surf_file%ncs(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%ncsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%ncsws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%ncsws )  .AND.                     &
-                     ALLOCATED( surf_file%ncsws   ) )                          & 
+                     ALLOCATED( surf_file%ncsws   ) )                          &
                    surf_target%ncsws(m_target) = surf_file%ncsws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%qrs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qis' ) /= 0 )  THEN
+                IF ( ALLOCATED( surf_target%qis )  .AND.                       &
+                     ALLOCATED( surf_file%qis   ) )                            &
+                  surf_target%qis(m_target) = surf_file%qis(m_file)
+             ENDIF
+
+             IF ( INDEX( restart_string(1:length), '%qisws' ) /= 0 )  THEN
+                IF ( ALLOCATED( surf_target%qisws )  .AND.                     &
+                     ALLOCATED( surf_file%qisws   ) )                          &
+                   surf_target%qisws(m_target) = surf_file%qisws(m_file)
+             ENDIF
+
+             IF ( INDEX( restart_string(1:length), '%nis' ) /= 0 )  THEN
+                IF ( ALLOCATED( surf_target%nis )  .AND.                       &
+                     ALLOCATED( surf_file%nis   ) )                            &
+                   surf_target%nis(m_target) = surf_file%nis(m_file)
+             ENDIF
+
+             IF ( INDEX( restart_string(1:length), '%nisws' ) /= 0 )  THEN
+                IF ( ALLOCATED( surf_target%nisws )  .AND.                     &
+                     ALLOCATED( surf_file%nisws   ) )                          &
+                   surf_target%nisws(m_target) = surf_file%nisws(m_file)
+             ENDIF
+
+             IF ( INDEX( restart_string(1:length), '%qrs' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%qrs )  .AND.                       &
-                     ALLOCATED( surf_file%qrs   ) )                            & 
+                     ALLOCATED( surf_file%qrs   ) )                            &
                   surf_target%qrs(m_target) = surf_file%qrs(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%qrsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%qrsws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%qrsws )  .AND.                     &
-                     ALLOCATED( surf_file%qrsws   ) )                          & 
+                     ALLOCATED( surf_file%qrsws   ) )                          &
                    surf_target%qrsws(m_target) = surf_file%qrsws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%nrs' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%nrs' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%nrs )  .AND.                       &
-                     ALLOCATED( surf_file%nrs   ) )                            & 
+                     ALLOCATED( surf_file%nrs   ) )                            &
                    surf_target%nrs(m_target) = surf_file%nrs(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%nrsws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%nrsws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%nrsws )  .AND.                     &
-                     ALLOCATED( surf_file%nrsws   ) )                          & 
+                     ALLOCATED( surf_file%nrsws   ) )                          &
                    surf_target%nrsws(m_target) = surf_file%nrsws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%sasws' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%sasws' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%sasws )  .AND.                     &
-                     ALLOCATED( surf_file%sasws   ) )                          & 
+                     ALLOCATED( surf_file%sasws   ) )                          &
                    surf_target%sasws(m_target) = surf_file%sasws(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%mom_uv' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%mom_uv' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%mom_flux_uv )  .AND.               &
-                     ALLOCATED( surf_file%mom_flux_uv   ) )                    & 
+                     ALLOCATED( surf_file%mom_flux_uv   ) )                    &
                    surf_target%mom_flux_uv(m_target) =                         &
                                            surf_file%mom_flux_uv(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%mom_w' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%mom_w' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%mom_flux_w )  .AND.                &
-                     ALLOCATED( surf_file%mom_flux_w   ) )                     & 
+                     ALLOCATED( surf_file%mom_flux_w   ) )                     &
                    surf_target%mom_flux_w(m_target) =                          &
                                            surf_file%mom_flux_w(m_file)
              ENDIF
 
-             IF ( INDEX( restart_string(1:length), '%mom_tke' ) /= 0 )  THEN 
+             IF ( INDEX( restart_string(1:length), '%mom_tke' ) /= 0 )  THEN
                 IF ( ALLOCATED( surf_target%mom_flux_tke )  .AND.              &
-                     ALLOCATED( surf_file%mom_flux_tke   ) )                   & 
+                     ALLOCATED( surf_file%mom_flux_tke   ) )                   &
                    surf_target%mom_flux_tke(0:1,m_target) =                    &
                                            surf_file%mom_flux_tke(0:1,m_file)
@@ -5102,9 +5405,9 @@
     END SUBROUTINE surface_rrd_local
 
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Counts the number of surface elements with the same facing, required for 
+!> Counts the number of surface elements with the same facing, required for
 !> reading and writing restart data.
 !------------------------------------------------------------------------------!
@@ -5129,5 +5432,5 @@
 ! Description:
 ! ------------
-!> Routine maps surface data read from file after restart - 1D arrays. 
+!> Routine maps surface data read from file after restart - 1D arrays.
 !------------------------------------------------------------------------------!
     SUBROUTINE surface_restore_elements_1d( surf_target, surf_file,            &
@@ -5140,13 +5443,13 @@
 
        IMPLICIT NONE
-    
+
        INTEGER(iwp) ::  i         !< running index along x-direction, refers to former domain size
        INTEGER(iwp) ::  ic        !< running index along x-direction, refers to current domain size
        INTEGER(iwp) ::  j         !< running index along y-direction, refers to former domain size
-       INTEGER(iwp) ::  jc        !< running index along y-direction, refers to former domain size        
+       INTEGER(iwp) ::  jc        !< running index along y-direction, refers to former domain size
        INTEGER(iwp) ::  m         !< surface-element index on file
        INTEGER(iwp) ::  mm        !< surface-element index on current subdomain
        INTEGER(iwp) ::  nxlc      !< index of left boundary on current subdomain
-       INTEGER(iwp) ::  nxlf      !< index of left boundary on former subdomain 
+       INTEGER(iwp) ::  nxlf      !< index of left boundary on former subdomain
        INTEGER(iwp) ::  nxrf      !< index of right boundary on former subdomain
        INTEGER(iwp) ::  nysc      !< index of north boundary on current subdomain
@@ -5159,10 +5462,10 @@
        INTEGER(iwp) ::  nys_on_file !< southmost index on file
 
-       INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index_c             
-       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+       INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index_c
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: &
                             start_index_on_file   !< start index of surface elements on file
-       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: &
                             end_index_on_file     !< end index of surface elements on file
-       
+
        REAL(wp), DIMENSION(:) ::  surf_target !< target surface type
        REAL(wp), DIMENSION(:) ::  surf_file   !< surface type on file
@@ -5186,10 +5489,10 @@
 
     END SUBROUTINE surface_restore_elements_1d
-   
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Routine maps surface data read from file after restart - 2D arrays
-!------------------------------------------------------------------------------! 
+!------------------------------------------------------------------------------!
     SUBROUTINE surface_restore_elements_2d( surf_target, surf_file,            &
                                             start_index_c,                     &
@@ -5201,13 +5504,13 @@
 
        IMPLICIT NONE
-    
+
        INTEGER(iwp) ::  i         !< running index along x-direction, refers to former domain size
        INTEGER(iwp) ::  ic        !< running index along x-direction, refers to current domain size
        INTEGER(iwp) ::  j         !< running index along y-direction, refers to former domain size
-       INTEGER(iwp) ::  jc        !< running index along y-direction, refers to former domain size        
+       INTEGER(iwp) ::  jc        !< running index along y-direction, refers to former domain size
        INTEGER(iwp) ::  m         !< surface-element index on file
        INTEGER(iwp) ::  mm        !< surface-element index on current subdomain
        INTEGER(iwp) ::  nxlc      !< index of left boundary on current subdomain
-       INTEGER(iwp) ::  nxlf      !< index of left boundary on former subdomain 
+       INTEGER(iwp) ::  nxlf      !< index of left boundary on former subdomain
        INTEGER(iwp) ::  nxrf      !< index of right boundary on former subdomain
        INTEGER(iwp) ::  nysc      !< index of north boundary on current subdomain
@@ -5221,12 +5524,12 @@
 
        INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index_c !< start index of surface type
-       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: &
                             start_index_on_file   !< start index of surface elements on file
-       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: & 
+       INTEGER(iwp), DIMENSION(nys_on_file:nyn_on_file,nxl_on_file:nxr_on_file) :: &
                             end_index_on_file     !< end index of surface elements on file
-       
+
        REAL(wp), DIMENSION(:,:) ::  surf_target !< target surface type
        REAL(wp), DIMENSION(:,:) ::  surf_file   !< surface type on file
-       
+
        ic = nxlc
        DO  i = nxlf, nxrf
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4501)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4502)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-!
-!
+! 
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+!
+! 4472 2020-03-24 12:21:00Z Giersch
 ! OPENACC COPYIN directive for ddx and ddy added
 !
@@ -211,9 +214,10 @@
     USE arrays_3d,                                                                                 &
         ONLY:  diss, diss_p, dzu, e_p, nc_p, nr_p, prho, pt, pt_p, pt_init, q, qc_p, qr_p, q_init, &
-               q_p, ref_state, rho_ocean, sa_p, s_p, tend, u, u_p, v, vpt, v_p, w_p
+               q_p, ref_state, rho_ocean, sa_p, s_p, tend, u, u_p, v, vpt, v_p, w_p,               &
+               qi_p, ni_p
 
 #if defined( __parallel )  &&  ! defined( _OPENACC )
     USE arrays_3d,                                                                                 &
-        ONLY:  e, nc, nr, qc, qr, s, w
+        ONLY:  e, nc, nr, qc, qr, s, w, qi, ni
 #endif
 
@@ -224,5 +228,5 @@
     USE bulk_cloud_model_mod,                                                                      &
         ONLY: bulk_cloud_model, calc_liquid_water_content, collision_turbulence,                   &
-              microphysics_morrison, microphysics_seifert
+              microphysics_morrison, microphysics_seifert, microphysics_ice_extension
 
     USE calc_mean_profile_mod,                                                                     &
@@ -432,5 +436,5 @@
                kh, km, momentumflux_output_conversion, nc, nr, p, ptdf_x, ptdf_y, qc, qr, rdf,     &
                rdf_sc, rho_air, rho_air_zw, s, tdiss_m, te_m, tpt_m, tu_m, tv_m, tw_m, ug, u_init, &
-               u_stokes_zu, vg, v_init, v_stokes_zu, w, zu
+               u_stokes_zu, vg, v_init, v_stokes_zu, w, zu, qi, ni
 
     USE control_parameters,                                                                        &
@@ -444,5 +448,6 @@
                sums_wsus_ws_l, sums_vs2_ws_l, sums_wsvs_ws_l, sums_ws2_ws_l, sums_wspts_ws_l,      &
                sums_wsqs_ws_l, sums_wssas_ws_l, sums_wsqcs_ws_l, sums_wsqrs_ws_l, sums_wsncs_ws_l, &
-               sums_wsnrs_ws_l, sums_wsss_ws_l, weight_substep, sums_salsa_ws_l
+               sums_wsnrs_ws_l, sums_wsss_ws_l, weight_substep, sums_salsa_ws_l,                   &
+               sums_wsqis_ws_l, sums_wsnis_ws_l
 
     USE surface_mod,                                                                               &
@@ -571,6 +576,8 @@
 !$ACC COPY(sums_wsqs_ws_l(nzb:nzt+1,0)) &
 !$ACC COPY(sums_wsqcs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsqis_ws_l(nzb:nzt+1,0)) &
 !$ACC COPY(sums_wsqrs_ws_l(nzb:nzt+1,0)) &
 !$ACC COPY(sums_wsncs_ws_l(nzb:nzt+1,0)) &
+!$ACC COPY(sums_wsnis_ws_l(nzb:nzt+1,0)) &
 !$ACC COPY(sums_wsnrs_ws_l(nzb:nzt+1,0)) &
 !$ACC COPY(sums_wsss_ws_l(nzb:nzt+1,0)) &
@@ -805,4 +812,8 @@
                 CALL exchange_horiz( nr_p, nbgp )
              ENDIF
+             IF ( bulk_cloud_model .AND. microphysics_ice_extension )  THEN
+                CALL exchange_horiz( qi_p, nbgp )
+                CALL exchange_horiz( ni_p, nbgp )
+             ENDIF
           ENDIF
           IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
@@ -894,5 +905,8 @@
                        CALL exchange_horiz( nr, nbgp )
                    ENDIF
-
+                   IF ( bulk_cloud_model  .AND.  microphysics_ice_extension )  THEN
+                       CALL exchange_horiz( qi, nbgp )
+                       CALL exchange_horiz( ni, nbgp )
+                   ENDIF
                 ENDIF
 
@@ -1219,6 +1233,8 @@
        !$ACC HOST(sums_wsqs_ws_l(nzb:nzt+1,0)) &
        !$ACC HOST(sums_wsqcs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsqis_ws_l(nzb:nzt+1,0)) &
        !$ACC HOST(sums_wsqrs_ws_l(nzb:nzt+1,0)) &
        !$ACC HOST(sums_wsncs_ws_l(nzb:nzt+1,0)) &
+       !$ACC HOST(sums_wsnis_ws_l(nzb:nzt+1,0)) &
        !$ACC HOST(sums_wsnrs_ws_l(nzb:nzt+1,0)) &
        !$ACC HOST(sums_wsss_ws_l(nzb:nzt+1,0)) &
